/* libfoXcontrol
 * Copyright (C) 2000 Josua Groeger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "FCDialog.h"

FXDEFMAP (FCDialog) FCDialogMap[]=
{
  FXMAPFUNC (SEL_COMMAND, FCDialog::ID_EXECUTE, FCDialog::onExecute),
  FXMAPFUNC (SEL_COMMAND, FCDialog::ID_APPLY, FCDialog::onApply),
  FXMAPFUNC (SEL_COMMAND, FCDialog::ID_HIDE, FCDialog::onHide)
};

FXIMPLEMENT (FCDialog, FXDialogBox, FCDialogMap, ARRAYNUMBER (FCDialogMap))

FCDialog::FCDialog (FXWindow* owner, FCComponent *component): FXDialogBox (owner, "")
{
  frame= new FCFrame (this, LAYOUT_FILL_X|LAYOUT_FILL_Y, component, this, MKUINT (ID_APPLY, SEL_COMMAND), NULL, this, MKUINT (ID_HIDE, SEL_COMMAND));
  char caption[200];
  sprintf (caption, "Settings: %s/%s", frame->getComponent ()->getSection (), frame->getComponent ()->getName ());
  setTitle (caption);
}

FCDialog::~FCDialog ()
{
  delete frame;
}

long FCDialog::onExecute (FXObject*, FXSelector, void*)
{
  return execute ();
}

long FCDialog::onApply (FXObject*, FXSelector, void*)
{
  settingsApplied= true;
}

long FCDialog::onHide (FXObject *obj, FXSelector sel, void *ptr)
{
  (settingsApplied)? handle (obj, MKUINT (FXDialogBox::ID_ACCEPT, SEL_COMMAND), ptr):
                     handle (obj, MKUINT (FXDialogBox::ID_CANCEL, SEL_COMMAND), ptr);
}

FXuint FCDialog::execute (FXuint placement= PLACEMENT_CURSOR)
{
  settingsApplied= false;
  return FXDialogBox::execute (placement);
}