/* libfoXcontrol
 * Copyright (C) 2000 Josua Groeger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* FCDialog is a dialog box containing an FCFrame. In order to provide access
 * to your foXcontrol component from your program just invoke execute (or use ID_EXECUTE).
*/

#ifndef FCDIALOG_H
#define FCDIALOG_H

#include "FCFrame.h"

class FCDialog: public FXDialogBox
{
  FXDECLARE(FCDialog)
  
protected:
  FCFrame* frame;
  bool settingsApplied;

  FCDialog () {};
    
public:
  FCDialog (FXWindow* owner, FCComponent *component);
  ~FCDialog ();

  enum
  {
    ID_EXECUTE= FXDialogBox::ID_LAST,
    ID_APPLY,
    ID_HIDE,
    ID_LAST
  };

  long onExecute (FXObject*, FXSelector, void*);
  long onApply (FXObject*, FXSelector, void*);
  long onHide (FXObject*, FXSelector, void*);
  
  FXuint execute (FXuint placement= PLACEMENT_CURSOR);
};

#endif